/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PROCESSO                                                 */
/* Tabela : PROCESSO                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PROCESSO' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PROCESSO
GO

CREATE TRIGGER DTULTATU_PROCESSO
ON PROCESSO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PROCESSO', null, 'CDNVPROCESSO=' + CDNVPROCESSO + ';'+
                                       'CDARVPROCESS=' + CDARVPROCESS + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PROCESSO
      SET DTULTATUPROC = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PROCESSO.CDARVPROCESS,0) = ISNULL(INSERTED.CDARVPROCESS,0)) AND
            (ISNULL(PROCESSO.CDPROCESSO,0)   = ISNULL(INSERTED.CDPROCESSO,0))   AND
            (ISNULL(PROCESSO.NMPROCESSO,0)   = ISNULL(INSERTED.NMPROCESSO,0))   AND
            (ISNULL(PROCESSO.CDNVPROCESSO,0) = ISNULL(INSERTED.CDNVPROCESSO,0));
   END;
END;
GO

